const БИБЛИОТЕКИ = [
    "https://bitbucket.org/gitjs/jquery/raw/3.5.1/0000",
    "https://bitbucket.org/gitjs/uikit/raw/3.2.0/0000",
];


// // // //


ОтобразитьВыборСтрокиТаблицы = мир =>
{
    // Очистить выбор для всех.
    for (var номер in мир.таблица.строки)
    {
        var элемент = мир.таблица.элемент(номер);
        элемент.removeClass("пример-выбора-таблицы");
    }
    // Задать выбор выбранному элементу.
    var элемент = мир.таблица.элемент(мир.номерВыбраннойСтроки);
    элемент.addClass("пример-выбора-таблицы");
};


// // // //


СоздатьПримерТаблицы = мир =>
{
    console.log("СоздатьПримерТаблицы");
    мир.таблица = new Таблица("пример-таблицы");
    мир.таблица.задатьЗаголовки(["№", "", "", "Название ⚬ 标题 ⚬ Name"]);
    var строки = [];
    for (var номер = 0; номер < 10; ++номер)
    {
        var строка = [
            String(номер+1),
            номер == 5 ? "v" : "",
            "",
            "Название_" + номер,
        ];
        строки.push(строка);
    }
    мир.таблица.задатьСтроки(строки);
    мир.таблица.выбор = (номер) =>
    {
        console.debug("Выбрали номер:", номер);
        мир.номерВыбраннойСтроки = номер;
        мир.уведомить("выбрали строку таблицы");
    };
    
    var вид = document.createElement("style");
    document.head.appendChild(вид);
    вид.innerHTML = `
#родитель-примера-таблицы
{
    display: inline-block;
}

.пример-выбора-таблицы
{
    background: #eeeeee;
}
    `;
};


// // // //


СоздатьПримерОкна = мир =>
{
    var окно = document.createElement("div");
    окно.classList.add("окно-на-весь-экран-с-отступом");
    окно.style.display = "none";
    document.body.appendChild(окно);

    окно.style.display = "block";

    окно.innerHTML = `
<center>
    <span class="uk-text-large">Окно</span>
    ⚬ <span class="uk-text-large uk-text-bold">窗</span> ⚬
    <span class="uk-text-large">Window</span>
</center>
<div id="родитель-примера-таблицы" class="прокрутка">
    <table id="пример-таблицы" class="uk-table uk-table-divider"></table>
</div>
    `;
    
    var вид = document.createElement("style");
    document.head.appendChild(вид);
    вид.innerHTML = `
.окно-на-весь-экран-с-отступом
{
    position: fixed;
    left: 1em;
    top: 1em;
    bottom: 1em;
    right: 1em;
}

.прокрутка
{
    overflow: auto;
    height: 100%;
}
    `;
    
    /*
    var элементСписок = document.getElementById(мир.окна.раскладки.список);
    мир.окна.раскладки.выборныйСписок = new ВыборныйСписок(элементСписок);
*/
};


// // // //


Очистить = мир =>
{
    document.body.innerHTML = "";
};


// // // //


ЗагрузитьБиблиотеки = мир =>
{
    мир.модули.использовали.подписатьРаз(function() {
        мир.уведомить("ручной пуск");
        мир.уведомить("загрузили библиотеки");
    });
    мир.модули.использовать(БИБЛИОТЕКИ);
};