СоздатьИндексыФишекМаджонга = мир =>
{
    мир.индексыФишекМаджонга = {};
    for (var н in мир.фишкиМаджонга)
    {
        var позиция = мир.фишкиМаджонга[н]["📍"];
        var индекс = индексПозицииФишкиМаджонга(позиция);
        мир.индексыФишекМаджонга[индекс] = н;
    };
};


// // // //


ВыбратьФишкуМаджонга = мир =>
{
    var номер = мир.фишкаМаджонгаДляВыбора;
    // Отсекаем выбор одной и той же фишки.
    if (
        мир.выбраннаяФишкаМаджонга &&
        мир.выбраннаяФишкаМаджонга == номер
    ) {
        return;
    }
    // Проверяем доступность с точки зрения правил Маджонга.
    var позиция = мир.фишкиМаджонга[номер]["📍"];
    var индекс = индексПозицииФишкиМаджонга(позиция);
    if (!фишкуМаджонгаМожноВыбрать(мир.индексыФишекМаджонга, индекс))
    {
        return;
    }

    мир.выбраннаяФишкаМаджонга = номер;
    мир.выбранныеФишкиМаджонга.push(номер);
    мир.уведомить("изменили выбранные фишки маджонга");
};